#!/usr/bin/perl
#!C:\perl\bin\perl.exe
=Copyright Infomation
==========================================================
    Program Name    : Mewsoft Auctionawy Migration Tool
    Program Version : 1.0
    Program Author   : Elsheshtawy, A. A.
    Home Page          : http://www.mewsoft.com
	Copyrights  2005 Mewsoft Corporation. All rights reserved.
==========================================================
=cut
#==========================================================
#                               Configuration
# You must install and create the sql tables for the Auctionawy 8.0
#--------------------------------------------------------------------------------------
#        Old NetAuction 6.x SQL Database Information Required
# Please set the following parameters for your old NetAuction
# SQL database information, we need to access it to get the data
# You can get these information from you site control panel
# If yuo can not remember your db user and password, add
# a new user with new password to the db from your site panel then
# update these information in your old admin.cgi->Configuration

#$Global{DB_Server1} ||= "MySQL"; # MySQL or MS_SQL
#$Global{DB_Driver1} ||= "mysql";
#$Global{DB_Host1} ||= "localhost";
#$Global{DB_Port1} ||= 3306;
#$Global{DB_DSN1} = ""; # With ODBC only
#$Global{DB_Name1} = ""; # Your old sql database name
#$Global{DB_UserID1} = ""; # Your old sql database user
#$Global{DB_Password1} = ""; # Your old sql database password
#--------------------------------------------------------------------------------------
#              Migrating Extra Languages Categories Names
# if you have create more than one language and already translated
# the  categories, then put the languages names between the () in the 
# line below and separate by space, for example if your default categories
# language is English and you cearted the languages Hebrew and Arabic
# then the line below should be like this:
# @Categories_Languages = qw(Hebrew Arabic);
# Leave it as it is if you did not create extra languages and translated them
# Do not put your site default language

@Categories_Languages = qw();

#--------------------------------------------------------------------------------------
#                  Do Not Modify Anything Below This Line
#==========================================================
#==========================================================
$| = 1;
print "Content-type: text/html\n\n";
use CGI::Carp qw(fatalsToBrowser); 
#==========================================================
BEGIN { 
	undef %Param;
	undef %Global;
	undef @User_Fields;
	undef @Items_Fields;
	undef @Category_Fields;
	undef %Cookies;
}
#==========================================================
BEGIN {
			unshift @INC, ".";
			$0 = $^X unless ($^X =~ m%(^|[/\\])(perl)|(perl.exe)$%i);
			$Cwd = ".";
			if ($0 =~ m%^(.*)[/\\]%){$Cwd=$1; unshift @INC, $Cwd;};
			if (!open (PATH, "$Cwd/data/StartUp.pm")){
				if (!open (PATH, "./data/StartUp.pm")){
						die "can not open path file $Cwd/data/StartUp.pm or ./data/StartUp.pm: $!. Please make sure the directory data and all its subdirectories and files are writables.";
				}
			}
			@Config = <PATH>;
			close (PATH);
			foreach $Temp(@Config) {
					$Temp =~ s/\r?\n$//;
					$Temp =~ s/^\s+//;
					if (!$Temp || $Temp =~ /^\#/) {next;}
					($K, $V) = split('=', $Temp);
					$Global{$K} = $V;
			}
			if (! $Global{CGI_Dir}) {
						$0 = $^X unless ($^X =~ m%(^|[/\\])(perl)|(perl.exe)$%i);
						if ($0 =~ m%^(.*)[/\\]%){$Global{CGI_Dir}=$1};
						if (!-d $Global{CGI_Dir}) {
								$Global{CGI_Dir} = "";
								$Temp = $ENV{SCRIPT_FILENAME};
								@Temp = split (/[\/\\]/, $Temp);
								pop @Temp;
								$Temp = join ('/', @Temp);
								if (-d $Temp) {$Global{CGI_Dir}=$Temp;}
						}
						$Global{CGI_Dir} ||= ".";
			}
			$Global{CGI_Dir} =~ s/\\/\//g;
			if (!$Global{My_Account_Prog}) {
						$0 = $^X unless ($^X =~ m%(^|[/\\])(perl)|(perl.exe)$%i);
						$0 =~  m%^(.*)[/\\](.*)%;
						$Global{My_Account_Prog} = $2;
						$Global{My_Account_Prog} ||= undef;
			}
			if (!$Global{CGI_URL}) {
					$http = "http://"; $Domain = ""; $Script_URL = "";
					if ($ENV{HTTP_REFERER}) {if ($ENV{HTTP_REFERER} =~ m|^https://|i) {$http = "https://";}}
					if ($ENV{HTTP_HOST}) {$Domain = $http . $ENV{HTTP_HOST};}
					if ($ENV{SCRIPT_NAME}) {$Script_URL = $Domain . $ENV{SCRIPT_NAME};}
					@Temp = split (/[\/\\]/, $Script_URL);
					pop @Temp;
					$Global{CGI_URL} = join ('/', @Temp);
			}
			unshift @INC, $Global{CGI_Dir};
}
use Configuration;
use StartUp;
#==========================================================
&Program_Start;
$Script_URL = &Get_Script_URL;
#==========================================================
use RegisterLib;

$DemoMode = 0;

#==========================================================
	if ($DemoMode) {print &MigrationForm; exit 0;}

	if ($Param{DB_Connect}) {
				&GetDBInfo;
				&DB_Connect1; # connect to old sql db
				print &MigrationForm;
				&DB_Disconnect1; &Quit;
	}
	elsif ($Param{MigrateUsers}){
				print &MigrationForm;
				&GetDBInfo;
				&DB_Connect1; # connect to old sql db
				# Migrate users
				&Migrate_Users;
				&Update_Total_Accounts_Count;
				&DB_Disconnect1; &Quit;
	}
	elsif ($Param{MigrateItems}){
				print &MigrationForm;
				&GetDBInfo;
				&DB_Connect1; # connect to old sql db
				# Migrate items
				&Migrate_Items;
				&Update_Categories_Count;
				&DB_Disconnect1; &Quit;
	}
	elsif ($Param{MigrateCategories}){
				print &MigrationForm;
				&GetDBInfo;
				&DB_Connect1; # connect to old sql db
				# Migrate categories
				&Migrate_Categories;
				&Update_Categories_Count;
				&DB_Disconnect1; &Quit;
	}
	elsif ($Param{ConvertTables}){
				print &MigrationForm;
				&Convert_Tables_V6;
				&Quit;
	}
	elsif ($Param{LoadAllTables}){
				print &MigrationForm;
				&LoadAllTables;
				&Quit;
	}
	else {
				$Param{DB_Server1} = "MySQL"; # MySQL or MS_SQL
				$Param{DB_Driver1} = "mysql";
				$Param{DB_Host1} = "localhost";
				$Param{DB_Port1} = 3306;
				$Param{DB_DSN1} = "";
				$Param{DB_Name1} = "";
				$Param{DB_UserID1} = "";
				$Param{DB_Password1} = "";
				print &MigrationForm;
				&Quit;

	}

	#&DB_Connect1; # connect to old sql db
	#print "Migrating to Auctionawy 8.0<br><br>\n";
	#print "Connected to old SQL database...<br><br>\n";
	#&DB_Disconnect1; &Quit;
	#--------------------------------------------
	# Convert the sql tables delimiters 
	#&Convert_Tables_V6
	#&DB_Disconnect1; &Quit;
	#--------------------------------------------
	# Migrate users
	#&Migrate_Users;
	#&Update_Total_Accounts_Count;
	#&DB_Disconnect1; &Quit;
	#--------------------------------------------
	# Migrate categories
	#&Migrate_Categories;
	#&Update_Categories_Count;
	#&DB_Disconnect1; &Quit;
	
	# Migrate categories extra languages
	#&Migrate_Categories_Languages(@Categories_Languages);
	#&DB_Disconnect1; &Quit;
	#--------------------------------------------
#==========================================================
#==========================================================
sub GetDBInfo{
	$Global{DB_Server1} = $Param{DB_Server1};
	$Global{DB_Driver1} = $Param{DB_Driver1};
	$Global{DB_Host1} = $Param{DB_Host1};
	$Global{DB_Port1} = $Param{DB_Port1};
	$Global{DB_DSN1} = $Param{DB_DSN1};
	$Global{DB_Name1} = $Param{DB_Name1};
	$Global{DB_UserID1} = $Param{DB_UserID1};
	$Global{DB_Password1} = $Param{DB_Password1};
}
#==========================================================
sub Convert_Tables_V6{
my (@Files, $File, @Lines, $Line);

	print "Converting SQL tables files <br>\n";
	#------------------------------------------------------
	undef @Files;
	opendir(Dir, "$Global{Database_Dir}");
	foreach $File (readdir(Dir)) {
			if (-d "$Global{Database_Dir}/$File" || $File eq "." || $File eq ".." || $File =~ m/^\_/) { next;}
			push (@Files, $File);
    }
	closedir(Dir);
	#------------------------------------------------------
	foreach $File (@Files) {
			print "Converting SQL file $Global{Database_Dir}/$File <br>\n";
			open (IN, "$Global{Database_Dir}/$File") || print "Can not open file $Global{Database_Dir}/$File: $! <br>\n";
			@Lines = <IN>;
			close IN;

			open (OUT, ">$Global{Database_Dir}/$File") || print "Can not create file $Global{Database_Dir}/$File: $! <br>\n";
			foreach $Line (@Lines) {
					$Line =~ s/\~\|\|\~/\<\~\|\|\|\~\>/g;
					print OUT "$Line";
			}
			close OUT;
	}
	#------------------------------------------------------
	print "Done converting SQL tables files <br><br>\n\n";

}
#==========================================================
sub Migrate_Users{
my (@Users, $Total, $Counter, $User, %UserV6, %User, $Field, %Info);

	print "Migrating users <br><br>\n\n";

	@Users = &GetAllUsers_V6;
	$Total = @Users;
	print "Total Users Found: $Total <br><br>\n\n";

	$Counter = 0;
	foreach $User (@Users) {
			$Counter++;
			print "$Counter)- Moving user $User <br>\n";
			%UserV6 = &Get_User_V6($User);
		    undef %User;
		    foreach $Field (@User_Fields) {
				$User{$Field} = "";
		    }
			foreach $Field (keys %UserV6) {
				$User{$Field} = $UserV6{$Field};
		    }
			
			&Add_New_User(%User);

			undef %Info;

			$Info{User_ID} = $User{User_ID};
			$Info{Sell} = $Global{New_Users_Sellers};
			$Info{Buy} = $Global{New_Users_Buyers};
			$Info{Status} = $Global{New_Users_Status};
			$Info{Verified} = "";
			$Info{Verified1} = "";
			$Info{Verified2} = "";
			$Info{Partner} = "";
			$Info{Sponser} = "";
			$Info{Power} = "";
			$Info{Rated} = "";

			&Add_New_User_Info(%Info);
			#------------------------------------------------------
			if ($Global{Boardawy_Plugin}) {
					&AddNewForumUserInfo($User{User_ID});
			}
			#------------------------------------------------------
	}
	
	print "Done migrating users <br><br>\n\n";
}
#==========================================================
sub GetAllUsers_V6{
my ($Query, $sth, @Users, $User);

	$Query = qq!SELECT User_ID FROM Users ORDER BY User_ID ASC!;
	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Users;
	while (($User) = $sth->fetchrow_array){push @Users, $User;}
	$sth->finish;
	return @Users;
}
#==========================================================
sub Get_User_V6{
my ($User_ID) = @_;
my ($Query, %User, $sth);

	$User_ID = $dbh1->quote($User_ID);
	$Query = qq!SELECT * FROM Users WHERE User_ID = $User_ID!;
	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute() || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %User;
	while ($Temp = $sth->fetchrow_hashref){%User = %{$Temp};}
	$sth->finish;
	return %User;
}
#==========================================================
sub DB_Connect1{
my ($Driver);

	if ($Global{DB_Driver1} =~ m/ODBC/i) {
		$dbh1 = DBI->connect("DBI:ODBC:$Global{DB_DSN1}", $Global{DB_UserID1}, $Global{DB_Password1}) || &DB_Exit("DBI:ODBC:$Global{DB_DSN1} <br>Line ".__LINE__ . ", File ". __FILE__);
		return;
	}

   $DSN1 = "DBI:$Global{DB_Driver1}:database=$Global{DB_Name1};host=$Global{DB_Host1};port=$Global{DB_Port1}";
   $dbh1 = DBI->connect($DSN1, $Global{DB_UserID1}, $Global{DB_Password1}) || &DB_Exit("$DSN1");
}
#==========================================================
sub DB_Disconnect1{
   $sth1->finish if($sth1);
   $dbh1->disconnect if($dbh1);
}
#==========================================================
sub Migrate_Categories{
my (@Categories, $Total, $Lang, $Counter, $Category, %Category);
my ($Name, $Description, $Active, $Accept, $Teaser, $Adult, $Domain);
my ($Login, $Icon, $Format, $Template, $Meta_Title, $Meta_Description);
my ($Meta_Keywords, $Query);

	print "Migrating Categories <br><br>\n\n";

	@Categories = &GetAllCategoriesID_V6;
	$Total = @Categories;
	
	print "Total Categories Found: $Total <br><br>\n\n";
	
	$Lang = $dbh->quote($Global{Language});

	$Counter = 0;
	foreach $Category (@Categories) {
						$Counter++;
						print "$Counter)- Migrating Category $Category <br>\n";

						%Category = &GetCategory_V6($Category);

						$Name = $dbh->quote($Category{Name});
						$Description = $dbh->quote($Category{Description});

						$Active = $dbh->quote($Category{Active});
						$Accept = $dbh->quote($Category{Accept});
						$Teaser = $dbh->quote($Category{Teaser});
						$Adult = $dbh->quote($Category{Adult});
						$Domain = $dbh->quote($Category{Domain});
						$Login = $dbh->quote($Category{Login});
						$Icon = $dbh->quote($Category{Icon});
						$Format = $dbh->quote($Category{Format});
						$Template = $dbh->quote($Category{Template});

						$Meta_Title =  $dbh->quote($Category{Meta_Title});
						$Meta_Description = $dbh->quote($Category{Meta_Description});
						$Meta_Keywords = $dbh->quote($Category{Meta_Keywords});

						$Query = qq!INSERT INTO Auction_Categories set 
													Cat_ID=$Category{Cat_ID},
													Parent=$Category{Parent},
													Active=$Active,
													Accept=$Accept,
													Sort=$Category{Sort},
													Teaser=$Teaser,
													Count=$Category{Count},
													Sub_Count=$Category{Sub_Count},
													Adult=$Adult,
													Domain=$Domain,
													Login=$Login,
													Icon=$Icon,
													Format=$Format,
													Template=$Template
												!;
    
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

						$Query = qq!INSERT INTO Auction_Categories_Name set Cat_ID=$Category{Cat_ID}, Lang=$Lang, Name=$Name!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

						$Query = qq!INSERT INTO Auction_Categories_Description set Cat_ID=$Category{Cat_ID}, Lang=$Lang, Description=$Description!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

						$Query = qq!INSERT INTO Auction_Categories_Meta set Cat_ID=$Category{Cat_ID}, Lang=$Lang, Meta_Title=$Meta_Title,  Meta_Description=$Meta_Description, Meta_Keywords=$Meta_Keywords!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}
	
	print "Done migrating categories <br><br>\n\n";
}
#==========================================================
sub GetAllCategoriesID_V6{
my ($Query, %Categories, $sth, $ID);

	$Query = qq!SELECT Cat_ID FROM Auction_Categories!;
	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef %Categories;
	while(($ID) = $sth->fetchrow_array) {
		$Categories{$ID}=1;
	}
	$sth->finish;
	return keys %Categories;
}
#==========================================================
sub GetCategory_V6{
my ($Cat_ID) = @_;
my ($Temp, $Query, $sth, %Category);
my ($Title, $Description, $Keywords);

	undef %Category;
	$Query = qq!SELECT * FROM Auction_Categories WHERE Cat_ID=$Cat_ID!;
	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	if ($Temp = $sth->fetchrow_hashref) {%Category = %{$Temp};}
	$sth->finish;

	if ($Global{DB_Server} eq "MS_SQL") {
			$Query = qq!SELECT TOP 1 * FROM Auction_Meta WHERE Cat_ID = $Cat_ID!;
	}
	else{
			$Query = qq!SELECT * FROM Auction_Meta WHERE Cat_ID = $Cat_ID LIMIT 1!;
	}

	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);

	while(($Cat_ID, $Title, $Description, $Keywords) = $sth->fetchrow_array){
					$Category{Meta_Title} = $Title;
					$Category{Meta_Description} = $Description;
					$Category{Meta_Keywords} = $Keywords;
	}

	$sth->finish;

	return %Category;
}
#==========================================================
sub Migrate_Categories_Languages{
my (@Languages) = @_;
my (@Categories, $Total, $Language, $File, %Lang, $Lang, $Counter, $Name, $Query);

	if (!@Languages) {return;}
	print "Migrating Categories Languages <br><br>\n\n";

	@Categories = &GetAllCategoriesID_V6;
	$Total = @Categories;
	
	print "Total Categories Found: $Total <br><br>\n\n";
	
	foreach $Language (@Languages) {
			if (!$Language) {next;}
			print "Migrating Category Language $Language <br>\n";
			$File = "$Global{Data_Dir}/language/$Language/Categories.pm";
			%Lang = &GetLanguageFile($File);

			$Lang = $dbh->quote($Language);

			$Counter = 0;
			foreach $Category (@Categories) {
						$Counter++;
						print "$Counter)- Migrating Category Language $Category <br>\n";
						$Name =  $dbh->quote($Lang{$Category});
						$Query = qq!INSERT INTO Auction_Categories_Name set Cat_ID=$Category, Lang=$Lang, Name=$Name!;
						$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
			}
	}

	print "<br>Done Migrating Categories Languages<br><br>\n\n";
}
#==========================================================
sub GetLanguageFile{ 
my ($Filename) = shift;
my (%Langs, @Variables, $Line);
my ($Key, $Value);

	open(FILE, "$Filename") || &Exit("Error: Can't open language file $Filename: $!" ."<br>Line ". __LINE__ . ", File ". __FILE__);
	@Variables = <FILE>;
	close(FILE);
	
	undef %Langs;
	foreach $Line (@Variables) {
		chomp($Line);
		($Key, $Value) = split("~==~", $Line);
		#$Value =~ s/\'/\&\#39\;/g;
		$Langs{$Key}="$Value";
	}

	return  %Langs;
}
#==========================================================
sub Migrate_Items{
my (@Items, $Total, $Currency, $Counter, $Item, %Item);
my ($User_ID, $Title, $Description, $Image, $Duration, $Private);
my ($Bold, $Colored, $Featured, $Featured1, $Gift_Icon, $Media);
my ($Item_Language, $Gallery, $Gallery_Img, $Banner, $Homepage);
my ($ShipAddress, $Query);

	print "Migrating Items <br><br>\n\n";

	@Items = &GetAllItems_V6;
	$Total = @Items;
	
	print "Total Items Found: $Total <br><br>\n\n";
	
	$Currency = $dbh->quote($Global{DefaultCurrency});

	$Counter = 0;
	foreach $Item (@Items) {
			$Counter++;
			if (!$Item) {next;}
			print "$Counter)- Migrating Item $Item <br>\n";
			%Item = &GetItem_V6($Item);
			if (!%Item) {next;}

			$User_ID = $dbh->quote($Item{User_ID});
			$Title = $dbh->quote($Item{Title});
			$Description = $dbh->quote($Item{Description});
			$Image = $dbh->quote($Item{Image});
			$Duration = $dbh->quote($Item{Duration});
			$Private = $dbh->quote($Item{Private});
			$Bold = $dbh->quote($Item{Bold});
			$Colored = $dbh->quote($Item{Colored});
			$Featured = $dbh->quote($Item{Featured});
			$Featured1 = $dbh->quote($Item{Featured1});
			$Gift_Icon = $dbh->quote($Item{Gift_Icon});
			$Media = $dbh->quote($Item{Media});
			$Item_Language = $dbh->quote($Item{Item_Language});
			$Gallery = $dbh->quote($Item{Gallery});
			$Gallery_Img = $dbh->quote($Item{Gallery_Img});
			$Banner = $dbh->quote($Item{Banner});
			$Homepage = $dbh->quote($Item{Homepage});
			$ShipAddress = $dbh->quote($Item{Location});

			$Query = qq!INSERT INTO Items set 
									ID=$Item{ID},
									Cat_ID=$Item{Cat_ID},
									CatA_ID=0,
									User_ID=$User_ID,
									
									Bids=$Item{Bids},
									Current_Bid=$Item{Current_Bid},
									Sponser=$Item{Sponser},
									Price=$Item{Price},
									
									Title=$Title,
									Description=$Description,
									Image=$Image,
									Quantity=$Item{Quantity},
									Sold=$Item{Sold},

									Start_Bid=$Item{Start_Bid},
									Increment=$Item{Increment},
									Reserve=$Item{Reserve},
									Buy_Price=$Item{Buy_Price},

									Duration=$Duration,
									Start_Time=$Item{Start_Time},
									End_Time=$Item{End_Time},

									Resubmit=$Item{Resubmit},
									Resubmited=$Item{Resubmited},

									Private=$Private,
									
									PaymentMethods='',
									PaymentDetails='',
									
									ShipTo='',
									ShipToDetails='',
									ShipTime='',

									ShipPayment='',
									ShipPaymentDetails='',
									
									Bold=$Bold,
									Colored=$Colored,
									Featured=$Featured,
									Featured1=$Featured1,
									Gift_Icon=$Gift_Icon,
									Media=$Media,
									Media_Show=$Item{Media_Show},

									Item_Language=$Item_Language,
									
									Gallery=$Gallery,
									Gallery_Img=$Gallery_Img,
									
									Banner=$Banner,

									Homepage=$Homepage,
									Status=$Item{Status},
									Reason=$Item{Reason},
									
									Currency=$Currency,
									SubTitle='',
									Type=0,
									ShipAddress=$ShipAddress,
									ShipZip='',
									ShipInsurance='',
									Insurance=0,
									ReturnPeriod='',
									ReturnMethod='',
									ReturnDetails='',
									ShipService1='',
									ShipCost1=0,
									ShipCostNext1=0,
									ShipService2='',
									ShipCost2=0,
									ShipCostNext2=0,
									ShipService3='',
									ShipCost3=0,
									ShipCostNext3=0,
									ShipDetails='',
									PackageWeight=0,
									PackageWeight1='',
									PackageType='',
									PackageW=0,
									PackageH=0,
									PackageL=0,
									PackageUnit=0,
									SalesTax=0,
									ShipTax=0
								!;
			$dbh->do($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	}

	print "Done Migrating Items <br><br>\n\n";
}
#==========================================================
sub GetItem_V6{
my ($Item_ID) = @_;
my ($Field, $Query, $Temp, $sth, %Item);
	
	undef %Item;
	$Query = qq!SELECT * FROM Items WHERE ID=$Item_ID!;
	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	while ($Temp = $sth->fetchrow_hashref){%Item = %{$Temp};}
	$sth->finish;
	return %Item;
}
#==========================================================
sub GetAllItems_V6{
my ($Field, $Query, $Temp, $sth, @Items);
	
	undef %Item;
	$Query = qq!SELECT ID FROM Items ORDER BY ID ASC!;
	$sth = $dbh1->prepare($Query) || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	$sth->execute || &DB_Exit($Query."<br>Line ". __LINE__ . ", File ". __FILE__);
	undef @Items;
	while (($ID) = $sth->fetchrow_array){push @Items, $ID;}
	$sth->finish;
	return @Items;
}
#==========================================================
sub MigrationForm{
my ($Form, $Status);
	
	if ($dbh1) {$Status=qq!<font color="red" ><b>Connected</b></font>!;}
	else {$Status=qq!<font color="blue" ><b>Not Connected</b></font>!;}
$Form=<<HTML;
<html>

<head>
<title>Mewsoft Migration Tools</title>
</head>

<body>

<form method="post" action="$Script_URL">
<p align="center"><u><b><font size="5" color="#FF0000">Welcome to Auctionawy 8.0 Migration Tool</font></b></u></p>
<div align="center">
  <center>
  <table border="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="600">
    <tr>
      <td width="100%">Please follow the following steps in order to safely 
      upgrade. If something happened during you upgrade, just empty the sql 
      tables and run this tool again</td>
    </tr>
  </table>
  </center>
</div>
<div align="center">
  <center>
<table border="1" cellpadding="4" cellspacing="0" style="border-collapse: collapse" bordercolor="#FF9900" width="600" height="238">
  <tr>
    <td width="100%" nowrap bgcolor="#F7D973"><b>Step 1</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <b>Connectect to NetAuction 6.xx Database</b></td>
  </tr>
  <tr>
    <td width="100%">Please enter your old NetAuction 6.xx SQL database 
    information. We need to connect to it to migrate the SQL tables for the &quot;Users&quot;,&quot;Items&quot;, 
    and &quot;Auction Categories&quot;. Copy these information from your admin->Configuration</td>
  </tr>
  <tr>
    <td width="100%" nowrap>
    <div align="center">
      <center>
      <table border="1" cellpadding="2" cellspacing="0" style="border-collapse: collapse" bordercolor="#F7D973" width="600">
      <tr>
        <td><b>Status:</b></td>
        <td width="100%">&nbsp;$Status</td>
      </tr>
      <tr>
        <td nowrap><b>DB Server:</b></td>
        <td width="100%">
        <p><input type="text" name="DB_Server1" value="$Param{DB_Server1}" size="20"> MySQL or MS_SQL</td>
      </tr>
      <tr nowrap>
        <td nowrap><b>DB Driver:</b></td>
        <td width="100%"><input type="text" name="DB_Driver1" value="$Param{DB_Driver1}"  size="20"> mysql</td>
      </tr>
      <tr>
        <td nowrap><b>DB Host:</b></td>
        <td width="100%"><input type="text" name="DB_Host1" value="$Param{DB_Host1}" size="20"> localhost</td>
      </tr>
      <tr>
        <td nowrap><b>DB Port:</b></td>
        <td width="100%"><input type="text" name="DB_Port1" value="$Param{DB_Port1}" size="20"> 3306</td>
      </tr>
      <tr>
        <td nowrap><b>DB Name:</b></td>
        <td width="100%"><input type="text" name="DB_Name1" value="$Param{DB_Name1}"  size="20"> </td>
      </tr>
      <tr>
        <td nowrap><b>DB User:</b></td>
        <td width="100%"><input type="text" name="DB_UserID1" value="$Param{DB_UserID1}" size="20"></td>
      </tr>
      <tr>
        <td nowrap><b>DB Password:</b></td>
        <td width="100%"><input type="password" name="DB_Password1" value="$Param{DB_Password1}" size="20"></td>
      </tr>
    </table>
      </center>
    </div>
    <p><input type="submit" value="Connect" name="DB_Connect">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <input type="reset" value="Reset" name="B2"><br>
&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#F7D973"><b>Step 2&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
    Migrate the Users Table</b></td>
  </tr>
  <tr>
    <td width="100%" height="19"><br>
&nbsp;&nbsp;&nbsp;&nbsp;
    <input type="submit" value="Migrate Users" name="MigrateUsers"><br>
&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19">&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19" bgcolor="#F7D973"><b>Step 3&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
    Migrate the Items Table</b></td>
  </tr>
  <tr>
    <td width="100%" height="19"><br>
&nbsp;&nbsp;&nbsp;&nbsp;
    <input type="submit" value="Migrate Items" name="MigrateItems"><br>
&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19">&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19" bgcolor="#F7D973"><b>Step 4&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
    Migrate the Categories Table</b></td>
  </tr>
  <tr>
    <td width="100%" height="19">&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19"><br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <input type="submit" value="Migrate Categories" name="MigrateCategories"><br>
&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19" bgcolor="#F7D973"><b>Step 5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
    Migrate the Compatible Tables</b></td>
  </tr>
  <tr>
    <td width="100%" height="19"><br>
    Before you click on <b>Load All Compatible SQL Tables</b>, login to your old 
    NetAuction admin center, click on &quot;Database &amp; SQL Manager&quot;, then click on 
    &quot;Backup SQL Database Into Text Files&quot; to backup your latest database.<br>
    <br>
    Next, transfer all the files in your old NetAuction installation under the 
    directory data/database to the same directory in your Auctionawy 8.0 
    installation. All files must be transferred in ASCII mode.<br>
&nbsp;<p dir="ltr">Then click on this button to convert all the NetAuction 6.xx 
    format to the Auctionawy 8.00 format:<br>
    <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <input type="submit" value="Convert All SQL Tables" name="ConvertTables"></p>
    <p dir="ltr">Now load all the converted compatible tables to the new 
    Auctionawy system by clicking on the button below:</p>
    <p dir="ltr">&nbsp;&nbsp;&nbsp;&nbsp;
    <input type="submit" value="Load All Compatible SQL Tables" name="LoadAllTables"></p>
    <p>&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" height="19" bgcolor="#F7D973"><b>Step 6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
    Transfer About Me and Media Files</b></td>
  </tr>
  <tr>
    <td width="100%" height="19">
    <p align="left" dir="ltr">The final step is to copy all files from inside 
    these directories from the old NetAuction to the same similar directories on 
    the new Auctionawy:</p>
    <p align="left">auctions/aboutme<br>
    auctions/aboutme_data<br>
    auctions/upload<br>
    auctions/thumb<br>
    auctions/featured<br>
    auctions/featured1<br>
    auctions/gallery<br>
    <br>
    The best way to do this is from the DOS prompt or Telnet using the copy 
    command, if you do not have access then you have to download files first to 
    your computer then upload back to the new Auctionawy directories.</p>
    <p align="left">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td>
  </tr>
  <tr>
    <td width="100%" height="19" bgcolor="#FF9900" align="center"><b>Finished</b></td>
  </tr>
</table>

  <p>Copyrights <font face="Times New Roman"><sup><font size="1"></font></sup>
  </font>2005 Mewsoft Corporation. All rights reserved.</p>

  </center>
</div>
<p>&nbsp;</p>
</form>

</body>

</html>
HTML
	
	return $Form;
}
#==========================================================
sub Do_SQL_Tables_Load_Unload{
my ($Table_Action, @Tables) = @_;
my ($Table, %Var, $File, $Counter, $Start, @Fields, %Skip, $Delimiter);
my ($Escape, $EOLine, @Fields1);

	undef %Var;
	$Start = time;
	
	# Skip built in Microsoft SQL server tables.
	$Skip{sysconstraints} = 1; 	$Skip{syssegments} = 1;
	
	foreach $Table(@Tables) {
			if ($Skip{$Table}) {print "<B>Skipping table $Table...</B><BR>"; next;}

			$File = "$Global{Database_Dir}/$Table\.sql\.pm";
			#$File = "$Table"."\.sql\.pm";
			$Delimiter = '<~|||~>'; $Escape = "\\"; $EOLine = "'\n'";
			#----------------------------------------------
			if ($Table_Action eq "UnLoad") {
					print "<B>Unloading table $Table...</B><BR>";
					print "File: $File<BR>";

					if ($Global{DB_File_Priv}) {
						unlink $File;
						&Export_Table($Table, $Delimiter, $Escape, $EOLine, $File);
						next;
					}
					open (FILE, ">$File") || &Exit("Cannot create $File: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);

					undef @Fields1;
					@Fields1 = &Get_Table_Fields($Table);

					$Query = qq!SELECT * FROM $Table!;
					$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
					$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
					 
					 $Rows = $sth->rows;
					 print "Rows: $Rows<BR><BR>";

					$Counter = 0;
					while (@Row = $sth->fetchrow_array) {
							$Line = "";

							foreach $Row (@Row) {
								$Row =~ s/\cM//g;
								$Row =~ s/\n/\\n/g;
								$Row =~ s/\r/\\r/g;
								$Line .= $Delimiter . $Row;
							}

							$Empty = @Fields1 - @Row;
							for $Row(1..$Empty) {
								$Line .= $Delimiter;
							}
							
							$Line =~ s/^\<\~\|\|\|\~\>//;

							print FILE "$Line\n";
							
							$Counter++;
							if (!($Counter % 10)) {print "<BR>\n";}
							print "$Counter ";
					}

					$sth->finish;
					close(FILE);

					print "<BR>Done...<BR><BR>";
			}#end if Unload
			#----------------------------------------------
			if ($Table_Action eq "Load") {
					print "<B>Loading table $Table...</B><BR>";
					
					if (-e "$File") {
							$Size = -s "$File";
							print "File Size: $Size Bytes<BR>";
							print "File: $File<BR>";
							
							&DB_Empty_Table($Table);

							if ($Global{DB_File_Priv}) {
								&Import_Table($Table, $Delimiter, $Escape, $EOLine, $File);
								next;
							}
							
							open (FILE, "$File") || &Exit("Cannot open $File: $!\n"."<BR>Line ". __LINE__ . ", File ". __FILE__);
							
							$Counter = 0;
							
							while ($Line = <FILE>){
									$Line =~ s/\n$//; 
									$Line .= $Delimiter. "x";
									@Row = split (/\<\~\|\|\|\~\>/, $Line); 
									pop @Row;
									$Line = "";
									foreach $Row (@Row) {
										$Row =~ s/\\n/\n/g;
										$Row =~ s/\\r/\r/g;
										$Line .=   $dbh->quote($Row) . ",";
									}
									$Line =~ s/\,$//;

									$Query = qq!INSERT INTO $Table VALUES($Line)!;
									$sth = $dbh->prepare($Query) || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);
									$sth->execute || &DB_Exit($Query."<BR>Line ". __LINE__ . ", File ". __FILE__);

									$Counter++;
									if (!($Counter % 10)) {print "<BR>\n";}
									print "$Counter ";
							}

							close(FILE);
							print "Done...<BR><BR>";
					}
					else{
							print "Error Loading table $Table: Table file $File does not exists\n";
					}
			}
			#----------------------------------------------
	}
	
	$Time = sprintf("%6.2f", (time - $Start)/60);
	print "<BR>Time consumed: $Time minutes<BR>";
	print qq!<P ALIGN="center"><A HREF="javascript:window.close()"><B><FONT COLOR="BLUE">Close This Window</FONT></B></a></P>!;
}
#==========================================================
sub GetCompatibleTables{
my (@Tables);

=cuts
Auction_Categories
Auction_Categories_Count
Auction_Categories_Description
Auction_Categories_Meta
Auction_Categories_Name
Auction_Categories_Zones
Auction_Favorites_Categories
Auction_Favorites_Users
Auction_Formats
AuctionLocation
AuctionLocationDescription
AuctionLocationName
Items
Users
Users_Info
=cut
	# Compatible tables
	@Tables = qw(
								Auction_Announcements
								Auction_Bids
								Auction_Featured
								Auction_Invoices
								Auction_Invoices_Track
								Auction_Lostlist
								Auction_Stats
								Auction_Views
								Auction_Watchlist
								Auction_Wonlist
								Bank_Accounts
								Banner_Accounts
								Banner_Campaigns
								Banner_Click_Log
								Banner_Daily_Stats
								Banner_Hourly_Stats
								Banner_Rotation_Index
								Banner_Zones
								Banners
								BidderTrack
								Block_List
								Credit_Cards
								Deposits
								FeedbackComments
								FeedbackRating
								FeedbackTrackBuyer
								FeedbackTrackSeller
								Item_Clicks
								Item_Views
								Mail
								Mail_Lists
								Pending_Users
								Related_Cats
								SellerTrack
								Terms
								Transactions
								Whos_Online
			);
	return @Tables;
}
#==========================================================
sub LoadAllTables{
	@Tables = &GetCompatibleTables;
	&Do_SQL_Tables_Load_Unload("Load", @Tables);
}
#==========================================================
